import rq

from app.mission_jobs.image_slice_job import image_slice_job
from config import Config
from connection import Connection


class Application:

    # def __init__(self, config):
    #     self._config = config

    def new_mission(self, data_path, tile_size, tile_grid, tile_format, epsg, auto_zoom, min_zoom, max_zoom, dms_id):
        # 影像切片
        config = Config()
        connection = Connection(config)
        # 添加任务
        q = rq.Queue(name='default', connection=connection.redis_conn)
        output_path = config.common.OUTPUT_PATH

        q.enqueue(image_slice_job,
                  kwargs={"data_path": data_path,
                          "output_path": output_path,
                          "tile_size": tile_size,
                          "tile_grid": tile_grid,
                          "tile_format": tile_format,
                          "epsg": epsg,
                          "auto_zoom": auto_zoom,
                          "min_zoom": min_zoom,
                          "max_zoom": max_zoom,
                          "dms_id": dms_id
                          },
                  job_timeout=int(config.common.JOB_TIMEOUT)
                  )
