import os

import requests
import rq

from app.mission_jobs.image_slice import slice_zxy
from config import Config
from connection import Connection


def image_slice_job(data_path, output_path, tile_size, tile_grid, tile_format, epsg, auto_zoom, min_zoom, max_zoom, dms_id):
    config = Config()
    # connection = Connection(config)

    # # 添加任务
    # q = rq.Queue(name='default', connection=connection.redis_conn)
    # for file_name in os.listdir(data_path):
    #     input_file = os.path.join(data_path, file_name)
    #     if os.path.splitext(file_name)[-1] == ".tif":
    #         q.enqueue(slice_zxy,
    #                   kwargs={"input_file": input_file,
    #                           "output_path": output_path,
    #                           "tile_size": tile_size,
    #                           "tile_grid": tile_grid,
    #                           "tile_format": tile_format,
    #                           "auto_zoom": auto_zoom,
    #                           "min_zoom": min_zoom,
    #                           "max_zoom": max_zoom},
    #                   job_timeout=int(config.common.JOB_TIMEOUT)
    #                   )

    for file_name in os.listdir(data_path):
        input_file = os.path.join(data_path, file_name)
        if os.path.splitext(file_name)[-1] == ".tif":
            slice_zxy(
                input_file=input_file,
                output_path=output_path,
                tile_size=tile_size,
                tile_grid=tile_grid,
                tile_format=tile_format,
                epsg=epsg,
                auto_zoom=auto_zoom,
                min_zoom=min_zoom,
                max_zoom=max_zoom,
            )

    # 获取token
    login_data = {
        'userName': config.oauth.userName,
        'password': config.oauth.password,
        'clientId': config.oauth.clientId,
        'serviceId': config.oauth.serviceId
    }

    login_rep = requests.post(config.oauth.URL + '/api/user/login', data=login_data).json()

    headers = {'token': login_rep.get('message')}

    # 修改dms
    data = {
        'id': dms_id,
        'columnId': config.dms.columnId,
        'state': 1
    }

    requests.post(config.dms.URL + '/content/updateAudit', headers=headers, data=data)
